(* ::Package:: *)

(* ::Title:: *)
(*Basis*)


SetDirectory @ NotebookDirectory[];
Get["../gkz_utils/gkz.m"]


(* ::Section:: *)
(*GKZ data*)


(* ::Subsection:: *)
(*A-matrix and nullspace*)


myA = {
	{1,1,1,1,1,1,1,1,1,1,1},
	{1,0,0,0,0,1,1,1,0,0,0},
	{0,1,0,0,0,0,0,0,1,1,0},
	{0,0,1,0,0,1,0,0,0,0,1},
	{0,0,0,1,0,0,1,0,1,0,0},
	{0,0,0,0,1,0,0,1,0,1,1}
};


ns = myA // NullSpace;
% // Map@MatrixForm


(* ::Subsection:: *)
(*lists*)


sigma = Range[6]


beta = Range[6] // Map@b // Map@ind2sym


(* ::Section:: *)
(*Basis*)


(* ::Subsection:: *)
(*rvecs*)


(* ::Text:: *)
(*dims 2 - 4 - 6*)


ints = {
	j[2,0,0,1,0,1],
	j[2,0,1,0,0,1],
	j[2,0,1,0,1,0],
	j[2,1,0,0,0,1],
	j[2,1,0,0,1,0],
	j[2,1,0,1,0,0],
	j[4,1,0,1,0,1],
	j[4,0,1,1,1,1],
	j[6,1,0,1,1,1],
	j[4,1,1,0,1,1],
	j[4,1,1,1,0,1],
	j[4,1,1,1,1,0],
	j[6,1,1,1,1,1]
};

rvecs = ints /. j[d0_,n__] :> rvec[myA, {d0/2,n}, ns]


(* ::Text:: *)
(*dims 4 - 6*)


(*ints = {
	j[4,0,0,2,0,1],
	j[4,0,2,0,0,1],
	j[4,0,2,0,1,0],
	j[4,2,0,0,0,1],
	j[4,1,0,0,2,0],
	j[4,1,0,1,0,0],
	j[4,1,0,1,0,1],
	j[4,0,1,1,1,1],
	j[6,1,0,1,1,1],
	j[4,1,1,0,1,1],
	j[4,1,1,1,0,1],
	j[4,1,1,1,1,0],
	j[6,1,1,1,1,1]
};

rvecs = ints /. j[d0_,n__] :> rvec[myA, {d0/2,n}, ns]*)


(* ::Subsection:: *)
(*D-module elements*)


script = diffop[myA, beta, sigma, rvecs];


dxs = Range[7,11] // Map@dx // Map@ind2sym


dbasis = script // runasir // niceop[#,dxs]&;


(*Export["basis_dim_2_4_6.m", dbasis]*)


dbasis = Import["basis_dim_2_4_6.m"]; 


(* ::Section::Closed:: *)
(*teX*)


elist = {\[Epsilon], \[Epsilon], \[Epsilon], \[Epsilon], \[Epsilon], -\[Epsilon], (\[Epsilon]-1)\[Epsilon], (\[Epsilon]-1)\[Epsilon], -(\[Epsilon]-2)(\[Epsilon]-1)\[Epsilon], (\[Epsilon]-1)\[Epsilon], -(\[Epsilon]-1)\[Epsilon], -(\[Epsilon]-1)\[Epsilon], (\[Epsilon]-2)(\[Epsilon]-1)\[Epsilon]}


dbaseByD=elist dbasis  // RightComposition[
	Simplify,
	Collect[#,j[__]]&,
	ReplaceAll[{
		j[n__] :> Times @@ ({Subscript["\[PartialD]", 7],Subscript["\[PartialD]", 8],Subscript["\[PartialD]", 9],Subscript["\[PartialD]", 10],Subscript["\[PartialD]", 11]} ^ {n}),
		Thread[{x7,x8,x9,x10,x11} -> {Subscript[z, 7],Subscript[z, 8],Subscript[z, 9],Subscript[z, 10],Subscript[z, 11]}]
	} // Flatten],
	Thread[
		Equal[
			Table[Subscript[e, i],{i,13}],
			#
		]
	]&,
(*	Map@TeXForm,
	ToString,
	StringReplace[{
		"," -> " \n \\\\ \\nonumber \n & \n",
		"\\epsilon" -> "\\e",
		"\\delta" -> "\\d",
		"e_" -> "(e')^{(\D)}_",
		"partial _" \[Rule] "partial_",
		"=" -> " &&= \n"
	}],
	StringDrop[#,1]&,
	StringDrop[#,-1]&,
	(*Export["basis_tex.txt",#]&,*)*)
	Identity
]
