(* ::Package:: *)

(* ::Title:: *)
(*From std to physical basis*)


SetDirectory @ NotebookDirectory[];
Get["../gkz_utils/gkz.m"]
Get["FiniteFlow.m"]


(* ::Section:: *)
(*import*)


(* ::Subsection::Closed:: *)
(*bases*)


(* ::Text:: *)
(*notation: j[d0, propagators]*)


ints = {
	j[2,0,0,1,0,1],
	j[2,0,1,0,0,1],
	j[2,0,1,0,1,0],
	j[2,1,0,0,0,1],
	j[2,1,0,0,1,0],
	j[2,1,0,1,0,0],
	j[4,1,0,1,0,1],
	j[4,0,1,1,1,1],
	j[6,1,0,1,1,1],
	j[4,1,1,0,1,1],
	j[4,1,1,1,0,1],
	j[4,1,1,1,1,0],
	j[6,1,1,1,1,1]
};


(* ::Text:: *)
(*standard monomials*)


std = {
	j[0,0,1,0,2],
	j[0,0,2,0,0],
	j[0,0,0,2,0],
	j[0,1,0,0,1],
	j[0,0,1,0,1],
	j[0,0,0,1,1],
	j[0,0,0,0,2],
	j[1,0,0,0,0],
	j[0,1,0,0,0],
	j[0,0,1,0,0],
	j[0,0,0,1,0],
	j[0,0,0,0,1],
	j[0,0,0,0,0]
};


(* ::Text:: *)
(*notation j[a,b,c,d] = dx7^a ... dx11^d*)


basis = Import["basis_dim_2_4_6.m"];


(* ::Subsection::Closed:: *)
(*Pfaffians*)


{p[x7], p[x8], p[x9], p[x10], p[x11]} = Import["pfaffian_std.m"];


num = p[x7] // Variables // numrep


(* ::Text:: *)
(*integrability*)


(*num@D[p[x7],x8] + num@p[x7].num@p[x8] - (num@D[p[x8],x7] + num@p[x8].num@p[x7])*)


(* ::Section:: *)
(*basis = C \[Bullet] d \[Bullet] std*)


(* ::Subsection::Closed:: *)
(*split*)


notstd = basis /. j[n__] /; ContainsAny[std, {j[n]}] :> 0;
instd  = basis /. j[n__] /; ContainsNone[std,{j[n]}] :> 0;


notstd + instd - basis


(* ::Subsection::Closed:: *)
(*\[Beta] = 0*)


c0 = CoefficientArrays[instd,std][[2]] // Normal;
c0 . std - instd 


(* ::Subsection::Closed:: *)
(*\[Beta] != 0*)


notjs = notstd // filter[_j] // order


(* ::Subsubsection::Closed:: *)
(*1*)


list1 = Intersection[notjs,der[std,1]]


rest1 = Complement[notjs,list1]


terms1 = notstd /. j[n__] /; ContainsNone[list1, {j[n]}] :> 0


c1 = CoefficientArrays[terms1, der[std,1]] [[2]] // Normal;
c1.std


(* ::Subsubsection::Closed:: *)
(*2*)


list2 = Intersection[rest1,der[std,2]]


rest2 = Complement[rest1,list2]


terms2 = notstd /. j[n__] /; ContainsNone[list2, {j[n]}] :> 0


c2 = CoefficientArrays[terms2, der[std,2]] [[2]] // Normal;
c2.std


(* ::Subsubsection::Closed:: *)
(*3*)


list3 = Intersection[rest2,der[std,3]]


rest3 = Complement[rest2,list3]


terms3 = notstd /. j[n__] /; ContainsNone[list3, {j[n]}] :> 0


c3 = CoefficientArrays[terms3, der[std,3]] [[2]] // Normal;
c3.std


(* ::Subsection::Closed:: *)
(*check*)


(* ::Text:: *)
(*check basis = sum(c_i \[Bullet] d_i \[Bullet] std)*)


c0.std + c1.der[std,1] + c2.der[std,2] + c3.der[std,3] - basis


c1 // MatrixForm;


(* ::Section:: *)
(*gauge*)


(* ::Subsection:: *)
(*d \[Bullet] std = f(Pfaffian) \[Bullet] std*)


(* ::Text:: *)
(*d_xi \[Bullet] std = p_xi \[Bullet] std*)


g1 = p[x7];
g2 = p[x8];
g3 = p[x9];


(* ::Text:: *)
(*claim: basis = g . std*)


g = c0 + c1.g1 + c2.g2 + c3.g3 // Factor;


(* ::Subsection:: *)
(*prefactors I*)


(* ::Text:: *)
(*LP * self-chosen prefactors (dropping E^(\[Epsilon]*EulerGamma), which was there for the box)*)


e = DiagonalMatrix[
	
	s12^\[Epsilon] *

	{1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , -1+2\[Epsilon] , 1 , 1 , 1 , 1} *
	
	\[Epsilon] ^ {0 , 0 , 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 , 1 , 1 , 2} *
	
	s12^{0 , 0 , 0 , 0 , 0 , 0 , 0 , 1 , 0 , 1 , 1 , 1 , 1} *
	
	(ints /. j[d0_,\[Nu]__] :> fac[{\[Nu]},s12][d0,1])
];


(* ::Subsection:: *)
(*gauge*)


(*pdirs = gauge[#, e, g]& /@ {x7,x8,x9,x10,x11};*)


(*Export["pfaffians_x7_x8_x9_x10_x11_basis_dims_2_4_6.m", pdirs]*)


{p7, p8, p9, p10, p11} = Import["pfaffians_x7_x8_x9_x10_x11_basis_dims_2_4_6.m"];


Variables /@ {p7, p8, p9, p10, p11}


(* ::Text:: *)
(*integrability*)


D[p7,x8] + p7.p8 - (D[p8,x7] + p8.p7) // num
